import SearchTree
import Data.List
import Test.QuickCheck

--(BST, isBST, treeInsert, emptyBST, traverseTree)

treeNub :: BST -> BST
treeNub bTree = treeInsertList nubbedList emptyBST where

    nubbedList = nub $ traverseTree bTree

    treeInsertList [] t = t
    treeInsertList (x:xs) t = treeInsertList xs (treeInsert x t)

prop_isTree t = isBST $ treeNub t

prop_no_dupes t = nub (traverseTree (treeNub t)) == traverseTree (treeNub t) 
